<?php

    namespace FederationLib\Enums\Standard;

    final class PeerAssociationType
    {
        /**
         * Indicates the parent peer is the owner of the child peer.
         */
        public const OWNER = 'owner';

        /**
         * Indicates the parent peer is the administrator of the child peer.
         */
        public const ADMIN = 'admin';

        /**
         * Indicates the parent peer is a moderator of the child peer.
         */
        public const MODERATOR = 'moderator';

        /**
         * Indicates the parent peer is a member of the child peer.
         */
        public const MEMBER = 'member';

        /**
         * Indicates the parent peer is banned from the child peer.
         */
        public const BANNED = 'banned';

        /**
         * Indicates the parent peer is an alternative address for the child peer.
         */
        public const ALTERNATIVE = 'alternative';

        /**
         * An array of all peer association types.
         */
        const ALL = [
            self::OWNER,
            self::ADMIN,
            self::MODERATOR,
            self::MEMBER,
            self::BANNED,
            self::ALTERNATIVE
        ];
    }