<?php

    namespace FederationLib;

    use FederationLib\Managers\ClientManager;
    use FederationLib\Managers\EventLogManager;

    class FederationLib
    {
        /**
         * @var ClientManager
         */
        private ClientManager $client_manager;

        /**
         * @var EventLogManager
         */
        private EventLogManager $event_log_manager;

        /**
         * FederationLib constructor.
         */
        public function __construct()
        {
            $this->client_manager = new ClientManager($this);
            $this->event_log_manager = new EventLogManager($this);
        }

        /**
         * Returns the Client manager instance
         *
         * @return ClientManager
         */
        public function getClientManager(): ClientManager
        {
            return $this->client_manager;
        }

        /**
         * @return EventLogManager
         */
        public function getEventLogManager(): EventLogManager
        {
            return $this->event_log_manager;
        }
    }