<?php

    namespace FederationLib\Interfaces;

    interface SerializableObjectInterface
    {
        /**
         * Returns an array representation of the object.
         *
         * @return array
         */
        public function toArray(): array;

        /**
         * Constructs object from an array representation.
         *
         * @param array $array
         * @return SerializableObjectInterface
         */
        public static function fromArray(array $array): SerializableObjectInterface;
    }